(* Copyright 1992 Digital Equipment Corporation. *)
(* Distributed only by permission. *)
(* Last modified on Sat Feb 12 14:06:03 PST 1994 by mcjones *)
(*      modified on Thu May  6 13:34:39 PDT 1993 by mjordan *)

MODULE OSErrorPosix EXPORTS OSError, OSErrorPosix;

IMPORT Atom, AtomList, Fmt, OSError, Uerror;

VAR errno_atoms := ARRAY [0..Uerror.Max] OF Atom.T {NIL, ..};
(* The table is initialized on a "lazy" basis. *)

PROCEDURE ErrnoAtom(n: CARDINAL): Atom.T =
  BEGIN
    IF errno_atoms[n] = NIL THEN
      errno_atoms[n] := Atom.FromText("errno=" & Fmt.Int(n))
    END;
    RETURN errno_atoms[n]
  END ErrnoAtom;

PROCEDURE Raise0(errno: INTEGER) RAISES {OSError.E} =
  BEGIN
    RAISE OSError.E(
      NEW(AtomList.T, head := ErrnoAtom(errno), tail := NIL))
  END Raise0;

PROCEDURE Raise() RAISES {OSError.E} =
  BEGIN
    Raise0(Uerror.errno)
  END Raise;

BEGIN
END OSErrorPosix.
