(* Copyright (C) 1990, Digital Equipment Corporation           *)
(* All rights reserved.                                        *)
(* See the file COPYRIGHT for a full description.              *)

(* Last modified on Fri Feb 18 07:49:04 PST 1994 by kalsow     *)

(* RTLinker defines the values initialized by the linker and
   startup code.
*)

UNSAFE INTERFACE RTLinker;

TYPE
  LinkInfo = UNTRACED REF RECORD

    (* global module table *)
    n_modules  : INTEGER;
    modules    : ADDRESS; (* REF ARRAY [0..n_modules-1] OF RT0.ModulePtr *)

    (* typecell table *)
    n_types    : INTEGER;
    types      : ADDRESS; (* REF ARRAY [0..n_types-1] OF RT0.TypeDefn; *)
    type_names : ADDRESS; (* REF ARRAY [0..n_types-1] OF Ctypes.char_star *)

    (* map from type id to typecode, sorted by type id. *)
    n_type_ids : INTEGER;
    type_ids   : ADDRESS; (* REF ARRAY [0..n_type_ids-1] OF INTEGER(type ID) *)
    type_codes : ADDRESS; (* REF ARRAY [0..n_type_ids-1] OF INTEGER(Typecode)*)

    (* external environment *)
    argc       : INTEGER;
    argv       : ADDRESS;
    envp       : ADDRESS;

    (* initial thread bounds *)
    bottom_of_stack : ADDRESS;
    top_of_stack    : ADDRESS;

    (* allocator statistics *)
    alloc_cnts  : ADDRESS; (* REF ARRAY [0..n_types-1] OF INTEGER; *)
    alloc_bytes : ADDRESS; (* REF ARRAY [0..n_types-1] OF INTEGER; *)
  END;

VAR info: LinkInfo;

END RTLinker.

