(* Copyright (C) 1989, Digital Equipment Corporation           *)
(* All rights reserved.                                        *)
(* See the file COPYRIGHT for a full description.              *)

(* Last modified on Mon Oct 11 11:04:30 PDT 1993 by wobber         *)
(*      modified on Wed Apr 21 17:30:38 PDT 1993 by mcjones        *)
(*      modified on Mon Feb 22 10:06:11 PST 1993 by jdd            *)
(*      modified on Fri Feb 19 11:29:24 PST 1993 by mjordan        *)
(*      modified on Fri Feb  7 00:04:41 PST 1992 by muller         *)
(*      modified on Wed Nov  6 10:49:18 PST 1991 by kalsow         *)


UNSAFE MODULE Stdio;

IMPORT File, FileRd, FileWr, OSError, Process, Rd, Thread,
       UnsafeRd, UnsafeWr, Wr;

PROCEDURE Close ()=
  <* FATAL Thread.Alerted *> 
  BEGIN
    IF stdin # NIL THEN
      TRY UnsafeRd.FastClose (stdin); EXCEPT Rd.Failure => END;
    END;
    IF stdout # NIL THEN
      TRY UnsafeWr.FastClose (stdout); EXCEPT Wr.Failure => END;
    END;
    IF stderr # NIL THEN
      TRY UnsafeWr.FastClose (stderr); EXCEPT Wr.Failure => END;
    END;
  END Close;

<*FATAL OSError.E*>
VAR hIn, hOut, hErr: File.T;
BEGIN
  Process.GetStandardFileHandles(stdin := hIn, stdout := hOut, stderr := hErr);
  IF hIn # NIL THEN stdin  := NEW(FileRd.T).init(hIn); ELSE stdin := NIL END;
  IF hOut # NIL THEN 
    stdout := NEW(FileWr.T).init(hOut, buffered := TRUE);
  ELSE
    stdout := NIL;
  END;
  IF hErr # NIL THEN
    stderr := NEW(FileWr.T).init(hErr, buffered := FALSE);
    bufferedStderr := NEW(FileWr.T).init(hErr, buffered := TRUE);
  ELSE
    stderr := NIL;
    bufferedStderr := NIL;
  END;
  Process.RegisterExitor (Close);
END Stdio.
